#! /usr/bin/perl -w
use strict;
use warnings;
#
# this script is created for calculating the protein-ligand interaction
# descriptors by using in-house program, called fitting.
#
# created by: G.B. Li
# created time: 2012.6.9
#

open IN,"$ARGV[0]";
open OUT,">$ARGV[1]";

my $i;
my $ligname;
my $line;
my $recname;
my $act;#pKd or pKi
my $resolution;#pdb

while(<IN>)
{
	chomp;
	$line=$_;#pdb id
		
	#get the information of this pdb
	#include resolution and pKd/pKi
	
	#now, prepare for calculate the each terms 
	$ligname=$line . "_ligand.mol2";
	$recname=$line . "_pocket.pdb";
	#copy the target and ligand file to current directory (tmp.pdb, tmp.mol2)
	system("cp /home/yang/lgb/idscore/inputdir/examples/testing/$line/$ligname tmp.mol2");
	system("cp /home/yang/lgb/idscore/inputdir/examples/testing/$line/$recname tmp.pdb");
	
	#create fitting index file
	open INDEX,">tmp.index";
print INDEX "# Parameter_Name		Parameter_value
#
# Input Files 
#
INPUT_RECEPTOR		tmp.pdb
INPUT_LIGAND		tmp.mol2
PARAMETER_DIRECTORY		../ffparameterdir/
INTERMEDIATE_DIRECTORY ../intermediatedir/
#
# Intermediate Files
#
BINDINGSITE_ATOM_FILE		../intermediatedir/bindingsite.txt
BINDINGSITE_GRID_FILE		../intermediatedir/grid.txt
#
# Output Files 
#
OUTPUT_FILE		../outputdir/leadscore_predicton.txt";
	
	close INDEX;
	#print "xxxx\n";
	#calcualate the terms
	system("./idscore tmp.index>result.txt");
	
	open DES,"result.txt";
	my $des_line;
	while(<DES>)
	{
		chomp;
		
		if($_ =~ /\s+The\ predict\ affinity\ is\ \:(\w+\.\w+).*/)
		{
			print "$1\n";
			$des_line=$1;
			last;
			#print "$1  $2  $3  $4\n";
		}
	}
	
	close DES;
	
	print OUT "$des_line\t$line\n";
	
	system("rm tmp.index");
	system("rm tmp.pdb");
	system("rm tmp.mol2");
	system("rm result.txt");
}

